<?php
namespace LMS\Tools\Homework\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Homework extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);

		if($this->acl->CheckPermissions('homework', 'manage')){
			$this->registerTask('add', 'edit');
			$this->registerTask('apply', 'save');
			$this->registerTask('save2new', 'save');
		} else
		if($this->acl->CheckPermissions('homework', 'view')){
			$this->registerTask('add', 'show');
			$this->registerTask('edit', 'show');
			$this->registerTask('apply', 'show');
			$this->registerTask('save', 'show');
			$this->registerTask('save2new', 'show');
			$this->registerTask('delete', 'show');
			$this->registerTask('stats', 'show');
		}
	}

	public function edit()
	{
		$courseId = $this->input->get('course_id', 0);
		$cid = $this->input->get('cid', array(), 'array');
		$id = (int) (count($cid) ? $cid[0] : $this->input->get('id', 0));

		$model = $this->getModel('Homework');
		$model->setState('courseId', $courseId);
		$model->setState('id', $id);

		$view = $this->getView('Homework');
		$view->setModel($model, true);

		$view->editItem();
	}

	public function cancel()
	{
		$jform = $this->input->get('jform', array(), 'array');
		$course_id = isset($jform['course_id']) ? $jform['course_id'] : $this->input->get('course_id', 0);

		$link = 'index.php?option=com_joomla_lms&task=homework.homeworks.show';
		$link .= '&course_id='.$course_id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function save()
	{
		$task = $this->input->get('task', 'save');
		$jform_data = $this->input->get('jform', array(), 'array');
		$courseId = $jform_data['course_id'];

		$jform_data['owner_id'] = $this->user->get('id');

//		echo '<pre>';
//		print_r($jform_data);
//		echo '</pre>';
//		die;

		$model = $this->getModel('Homework');
		$model->setState('courseId', $courseId);
		$lastInsertID = $model->save($jform_data);

		if($task == 'apply'){
			$link = 'index.php?option=com_joomla_lms&task=homework.homework.edit';
			$link .= '&course_id='.$courseId;
			$link .= '&id='.$lastInsertID;
		} else
		if($task == 'save2new'){
			$link = 'index.php?option=com_joomla_lms&task=homework.homework.edit';
			$link .= '&course_id='.$courseId;
		} else {
			$link = 'index.php?option=com_joomla_lms&task=homework.homeworks.show';
			$link .= '&course_id='.$courseId;
		}
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function delete()
	{
		$courseId = $this->input->get('course_id', 0);
		$cid = $this->input->get('cid', array(), 'array');

		if(is_array($cid) && count($cid)){
			$model = $this->getModel('Homework');

			jimport('joomla.utilities.arrayhelper');
			\JArrayHelper::toInteger($cid);

			if($this->acl->CheckPermissions('homework', 'manage')){
				$model->delete($cid);
			}
		}

		$link = 'index.php?option=com_joomla_lms&task=homework.homeworks.show';
		$link .= '&course_id='.$courseId;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	//STUDENT PART
	public function show()
	{
		$courseId = $this->input->get('course_id', 0);
		$id = $this->input->get('id', 0);
		$userId = $this->user->get('id');
		$Itemid = $this->input->get('Itemid', 0);

		if($this->acl->CheckPermissions('homework', 'view')){
			$modelHomework = $this->getModel('Homework');
			$modelHomework->setState('courseId', $courseId);
			$modelHomework->setState('id', $id);
			$modelHomework->setState('userId', $userId);

			$modelResult = $this->getModel('Result');
			$modelResult->setState('courseId', $courseId);
			$modelResult->setState('homeworkId', $id);
			$modelResult->setState('userId', $userId);

			$modelResult->setState('permissions.homework.manage', $this->acl->CheckPermissions('homework', 'manage'));
			$modelResult->setState('permissions.homework.view', $this->acl->CheckPermissions('homework', 'view'));

			$view = $this->getView('Homework');
			if($Itemid){
				$view->Itemid = $Itemid;
			}
			$view->setModel($modelHomework, true);
			$view->setModel($modelResult);

			$view->show();
		}
	}
}