<?php
namespace LMS\Tools\Homework\Tables;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Homework extends Base\Table
{
	protected $fieldMap = array(
		'id' => 'id',
		'course_id' => 'course_id',
		'owner_id' => 'owner_id',
		'is_limited' => 'is_limited',
		'title' => 'hw_name',
		'groups' => 'groups',
		'description' => 'hw_description',
		'short_description' => 'hw_shortdescription',
		'start_date' => 'post_date',
		'end_date' => 'end_date',
		'is_time_related' => 'is_time_related',
		'show_period' => 'show_period',
		'published' => 'published',
		'activity_type' => 'activity_type',
		'graded_activity' => 'graded_activity',
		'ordering' => 'ordering',
	);

	protected $alias = 'hw';

    public function __construct()
    {
        parent::__construct('#__lms_homework', 'id');
    }

	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub

		$this->addRelation(
			'homeworkResults',
			array(
				'table' => new HomeworkResults(),
				'type' => 'LEFT',
				'condition' => '{parent.id} = {child.hw_id} AND {parent.course_id} = {child.course_id}',
				'capacity' => self::MANY
			)
		);

//		$this->relations['homework_results'] = array(
//			'table' => new HomeworkResults(),
//			'type' => 'LEFT',
//			'condition' => '{parent.id} = {child.hw_id} AND {parent.course_id} = {child.course_id}',
//			'capacity' => self::MANY
//		);
	}
}

