<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * 
 */

namespace LMS\Tools\Users\Repositories;
 
defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;
use LMS\Libraries\Servicelocator;

class Staff extends Base\Repository
{	
	public function __construct($options = array()) 
	{
		parent::__construct($options);
		
		$config	= ServiceLocator::get('config');		
		$this->table = ServiceLocator::get('table_staff');
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{	
		$filters = (isset($filterOptions['list.filters']))?$filterOptions['list.filters']:array();
		$rolesIds = array();	
		
		if(isset($filterOptions['roles'])){
			if(in_array('teacher', $filterOptions['roles'])) {
				$rolesIds[] = 1;
			}
			if(in_array('assistant', $filterOptions['roles'])) {
				$rolesIds[] = 4;
			}
			if(in_array('admin', $filterOptions['roles'])) {
				$rolesIds[] = 5;
			}
			if(in_array('parent', $filterOptions['roles'])||in_array('ceo', $filterOptions['roles'])) {
				$rolesIds[] = 6;
			}			
		}
		
		if(isset($filterOptions['user_id']) && empty($filterOptions['user_id'])) {
			$filterOptions['user_id'] = array(-1);
		}
		
		if(!empty($filterOptions['user_id'])){
			if(is_array($filterOptions['user_id'])) {
				$strUsers = implode(',', $filterOptions['user_id']);
			} else {
				$strUsers = $filterOptions['user_id'];
			}						
			$query->where('staff.user_id IN ('.$strUsers.')');			
		}
		
		if(!empty($filterOptions['excluded_user_id'])){
			if(is_array($filterOptions['excluded_user_id'])) {
				$strUsers = implode(',', $filterOptions['excluded_user_id']);
			} else {
				$strUsers = $filterOptions['excluded_user_id'];
			}						
			$query->where('staff.user_id NOT IN ('.$strUsers.')');			
		}
		
		if(!empty($rolesIds)) {
			$query->where('staff.role_id IN ('.implode(',', $rolesIds).')');
		}
		
		if(!empty($filters['search'])) {
			$search = $filters['search'];
			$query->where('
				(					
					UPPER(staff.profile.email) LIKE UPPER(\'%'.$search.'%\') 
					OR UPPER(staff.profile.name) LIKE UPPER(\'%'.$search.'%\')
				)'				
			);			
		}
		
		return parent::prepareFilter($query, $filterOptions);
	}
}
