<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * 
 */

namespace LMS\Tools\Users\Repositories;
 
defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;
	
class User extends Base\Repository 
{
	protected $id;
		
	public function __construct($options = array()){
		parent::__construct($options);
		$this->table = new Tables\JoomlaUsers($this->db);
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{			
		if(!empty($filterOptions['search'])) {
			$search = $filterOptions['search'];
			$query->where('
				UPPER(joomlauser.username) LIKE UPPER(\'%'.$search.'%\') 
				OR UPPER(joomlauser.email) LIKE UPPER(\'%'.$search.'%\') 
				OR UPPER(joomlauser.name) LIKE UPPER(\'%'.$search.'%\')'
			);			
		}
		
		if(!empty($filterOptions['user_id']))
		{			
			if(is_array($filterOptions['user_id'])) {
				$strUsers = implode(',', $filterOptions['user_id']);
			} else {
				$strUsers = $filterOptions['user_id'];
			}
			
			$query->where('joomlauser.id IN ('.$strUsers.')');
		}
		
		return parent::prepareFilter($query, $filterOptions);
	}	
}
?>
